ViennaCL - The Vienna Computing Library: viennacl::linalg::opencl::amg Namespace Reference

ViennaCL - The Vienna Computing Library 1.7.1 Free open-source GPU-accelerated linear algebra and solver library. |

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Functions
viennacl::linalg::opencl::amg Namespace Reference

## Functions
template<typename NumericT >
void | amg_influence_trivial (compressed_matrix< NumericT > const &A, viennacl::linalg::detail::amg::amg_level_context &amg_context, viennacl::linalg::amg_tag &tag)
| Routine for taking all connections in the matrix as strong. More...
template<typename NumericT >
void | amg_influence_advanced (compressed_matrix< NumericT > const &A, viennacl::linalg::detail::amg::amg_level_context &amg_context, viennacl::linalg::amg_tag &tag)
| Routine for extracting strongly connected points considering a user-provided threshold value. More...
template<typename NumericT >
void | amg_influence (compressed_matrix< NumericT > const &A, viennacl::linalg::detail::amg::amg_level_context &amg_context, viennacl::linalg::amg_tag &tag)
| Dispatcher for influence processing. More...
void | enumerate_coarse_points (viennacl::linalg::detail::amg::amg_level_context &amg_context)
| Assign IDs to coarse points. More...
template<typename NumericT >
void | amg_coarse_ag_stage1_mis2 (compressed_matrix< NumericT > const &A, viennacl::linalg::detail::amg::amg_level_context &amg_context, viennacl::linalg::amg_tag &tag)
| AG (aggregation based) coarsening, single-threaded version of stage 1. More...
template<typename NumericT >
void | amg_coarse_ag (compressed_matrix< NumericT > const &A, viennacl::linalg::detail::amg::amg_level_context &amg_context, viennacl::linalg::amg_tag &tag)
| AG (aggregation based) coarsening. Partially single-threaded version (VIENNACL_AMG_COARSE_AG) More...
template<typename InternalT1 >
void | amg_coarse (InternalT1 &A, viennacl::linalg::detail::amg::amg_level_context &amg_context, viennacl::linalg::amg_tag &tag)
| Calls the right coarsening procedure. More...
template<typename NumericT >
void | amg_interpol_ag (compressed_matrix< NumericT > const &A, compressed_matrix< NumericT > &P, viennacl::linalg::detail::amg::amg_level_context &amg_context, viennacl::linalg::amg_tag &tag)
| AG (aggregation based) interpolation. Multi-Threaded! (VIENNACL_INTERPOL_SA) More...
template<typename NumericT >
void | amg_interpol_sa (compressed_matrix< NumericT > const &A, compressed_matrix< NumericT > &P, viennacl::linalg::detail::amg::amg_level_context &amg_context, viennacl::linalg::amg_tag &tag)
| Smoothed aggregation interpolation. (VIENNACL_INTERPOL_SA) More...
template<typename MatrixT >
void | amg_interpol (MatrixT const &A, MatrixT &P, viennacl::linalg::detail::amg::amg_level_context &amg_context, viennacl::linalg::amg_tag &tag)
| Dispatcher for building the interpolation matrix. More...
template<typename NumericT , unsigned int AlignmentV>
void | assign_to_dense (viennacl::compressed_matrix< NumericT, AlignmentV > const &A, viennacl::matrix_base< NumericT > &B)
template<typename NumericT >
void | smooth_jacobi (unsigned int iterations, compressed_matrix< NumericT > const &A, vector< NumericT > &x, vector< NumericT > &x_backup, vector< NumericT > const &rhs_smooth, NumericT weight)
| Jacobi Smoother (OpenCL version) More...

## Function Documentation

template<typename InternalT1 >

void viennacl::linalg::opencl::amg::amg_coarse | ( | InternalT1 & | A,
|  | viennacl::linalg::detail::amg::amg_level_context & | amg_context,
|  | viennacl::linalg::amg_tag & | tag
| ) |  |

Calls the right coarsening procedure.

Parameters

  A | Operator matrix on all levels
  amg_context | AMG hierarchy datastructures
  tag | AMG preconditioner tag

Definition at line 286 of file amg_operations.hpp.

template<typename NumericT >

void viennacl::linalg::opencl::amg::amg_coarse_ag | ( | compressed_matrix< NumericT > const & | A,
|  | viennacl::linalg::detail::amg::amg_level_context & | amg_context,
|  | viennacl::linalg::amg_tag & | tag
| ) |  |

AG (aggregation based) coarsening. Partially single-threaded version (VIENNACL_AMG_COARSE_AG)

Parameters

  A | Operator matrix
  amg_context | AMG hierarchy datastructures
  tag | AMG preconditioner tag

Definition at line 224 of file amg_operations.hpp.

template<typename NumericT >

void viennacl::linalg::opencl::amg::amg_coarse_ag_stage1_mis2 | ( | compressed_matrix< NumericT > const & | A,
|  | viennacl::linalg::detail::amg::amg_level_context & | amg_context,
|  | viennacl::linalg::amg_tag & | tag
| ) |  |

AG (aggregation based) coarsening, single-threaded version of stage 1.

Parameters

  A | Operator matrix on all levels
  amg_context | AMG hierarchy datastructures
  tag | AMG preconditioner tag

Definition at line 128 of file amg_operations.hpp.

template<typename NumericT >

void viennacl::linalg::opencl::amg::amg_influence | ( | compressed_matrix< NumericT > const & | A,
|  | viennacl::linalg::detail::amg::amg_level_context & | amg_context,
|  | viennacl::linalg::amg_tag & | tag
| ) |  |

Dispatcher for influence processing.

Definition at line 82 of file amg_operations.hpp.

template<typename NumericT >

void viennacl::linalg::opencl::amg::amg_influence_advanced | ( | compressed_matrix< NumericT > const & | A,
|  | viennacl::linalg::detail::amg::amg_level_context & | amg_context,
|  | viennacl::linalg::amg_tag & | tag
| ) |  |

Routine for extracting strongly connected points considering a user-provided threshold value.

Definition at line 71 of file amg_operations.hpp.

template<typename NumericT >

void viennacl::linalg::opencl::amg::amg_influence_trivial | ( | compressed_matrix< NumericT > const & | A,
|  | viennacl::linalg::detail::amg::amg_level_context & | amg_context,
|  | viennacl::linalg::amg_tag & | tag
| ) |  |

Routine for taking all connections in the matrix as strong.

Definition at line 48 of file amg_operations.hpp.

template<typename MatrixT >

void viennacl::linalg::opencl::amg::amg_interpol | ( | MatrixT const & | A,
|  | MatrixT & | P,
|  | viennacl::linalg::detail::amg::amg_level_context & | amg_context,
|  | viennacl::linalg::amg_tag & | tag
| ) |  |

Dispatcher for building the interpolation matrix.

Parameters

  A | Operator matrix
  P | Prolongation matrix
  amg_context | AMG hierarchy datastructures
  tag | AMG configuration tag

Definition at line 385 of file amg_operations.hpp.

template<typename NumericT >

void viennacl::linalg::opencl::amg::amg_interpol_ag | ( | compressed_matrix< NumericT > const & | A,
|  | compressed_matrix< NumericT > & | P,
|  | viennacl::linalg::detail::amg::amg_level_context & | amg_context,
|  | viennacl::linalg::amg_tag & | tag
| ) |  |

AG (aggregation based) interpolation. Multi-Threaded! (VIENNACL_INTERPOL_SA)

Parameters

  A | Operator matrix
  P | Prolongation matrix
  amg_context | AMG hierarchy datastructures
  tag | AMG configuration tag

Definition at line 311 of file amg_operations.hpp.

template<typename NumericT >

void viennacl::linalg::opencl::amg::amg_interpol_sa | ( | compressed_matrix< NumericT > const & | A,
|  | compressed_matrix< NumericT > & | P,
|  | viennacl::linalg::detail::amg::amg_level_context & | amg_context,
|  | viennacl::linalg::amg_tag & | tag
| ) |  |

Smoothed aggregation interpolation. (VIENNACL_INTERPOL_SA)

Parameters

  A | Operator matrix
  P | Prolongation matrix
  amg_context | AMG hierarchy datastructures
  tag | AMG configuration tag

Definition at line 343 of file amg_operations.hpp.

template<typename NumericT , unsigned int AlignmentV>

void viennacl::linalg::opencl::amg::assign_to_dense | ( | viennacl::compressed_matrix< NumericT, AlignmentV > const & | A,
|  | viennacl::matrix_base< NumericT > & | B
| ) |  |

Assign sparse matrix A to dense matrix B

Definition at line 400 of file amg_operations.hpp.

void viennacl::linalg::opencl::amg::enumerate_coarse_points | ( | viennacl::linalg::detail::amg::amg_level_context & | amg_context | ) |
| inline

Assign IDs to coarse points.

TODO: Use exclusive_scan on GPU for this.

Definition at line 96 of file amg_operations.hpp.

template<typename NumericT >

void viennacl::linalg::opencl::amg::smooth_jacobi | ( | unsigned int | iterations,
|  | compressed_matrix< NumericT > const & | A,
|  | vector< NumericT > & | x,
|  | vector< NumericT > & | x_backup,
|  | vector< NumericT > const & | rhs_smooth,
|  | NumericT | weight
| ) |  |

Jacobi Smoother (OpenCL version)

Parameters

  iterations | Number of smoother iterations
  A | Operator matrix for the smoothing
  x | The vector smoothing is applied to
  x_backup | (Different) Vector holding the same values as x
  rhs_smooth | The right hand side of the equation for the smoother
  weight | Damping factor. 0: No effect of smoother. 1: Undamped Jacobi iteration

Definition at line 427 of file amg_operations.hpp.